
// includes
#include "../gfx/opengl.hpp"
#include "RenderTarget.hpp"

namespace bleifrei {
	namespace gfx {

		void
		RenderTarget::swapBuffers(void)
		{
			glFlush();
			SwapBuffers(hDC);
		}

		void
		RenderTarget::activate(void)
		{
			if (!WGL_ARB_make_current_read_initialized) {
				wglMakeCurrent(hDC, hRC);
			}
			else {
				wglMakeContextCurrentARB(hDC, hDC, hRC);
			}

			if (doubleBuffered) {
				glDrawBuffer(GL_BACK);
				glReadBuffer(GL_BACK);
			}
			else {
				glDrawBuffer(GL_FRONT);
				glReadBuffer(GL_FRONT);
			}

			glViewport(0, 0, width, height);
		}

	}
}