
// includes
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/tex/Texture.hpp"

#include "Button.hpp"

using namespace bleifrei::gfx;
using namespace bleifrei::tex;
using namespace std;

Button::Button(const string &text, Font *font, int x, int y, int width, int height)
	: text(text), font(font), callback(0)
{
	move(x, y);
	resize(font->getWidth(text) + 20, height);
}

void Button::onPaintOverlay(int absx, int absy)
{
	if (isClicked() || isMouseOver())
	{
		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);

		glBegin(GL_QUADS);
			glVertex2i(absx, absy);
			glVertex2i(absx, absy + getHeight());
			glVertex2i(absx + getWidth(), absy + getHeight());
			glVertex2i(absx + getWidth(), absy);
		glEnd();

		glColor4f(192 / 255.0f, 192 / 255.0f, 192 / 255.0f, 1);

		glBegin(GL_LINE_LOOP);
			glVertex2i(absx, absy);
			glVertex2i(absx, absy + getHeight());
			glVertex2i(absx + getWidth(), absy + getHeight());
			glVertex2i(absx + getWidth(), absy);
		glEnd();
	}

	glColor4f(192 / 255.0f, 192 / 255.0f, 192 / 255.0f, 1);
	int offset = isClicked() ? 1 : 0;
	font->print(absx + (getWidth() - font->getWidth(text)) / 2 + offset, absy + (getHeight() - font->getHeight()) / 2 + offset, 1.0f, text);
}

void Button::onClick(int, int)
{
	if (callback) callback(this);
}
