
// includes
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/io/Console.hpp"
#include "bleifrei/tex/Texture.hpp"

#include "ConsoleOutput.hpp"

using namespace bleifrei::gfx;
using namespace bleifrei::io;
using namespace bleifrei::tex;
using namespace std;

extern int g_width;
extern int g_height;
extern Console &g_console;

ConsoleOutput::ConsoleOutput(Font *font, int x, int y, int width, int height) :
	font(font)
{
	move(x, y);
	resize(width, height);
}

void ConsoleOutput::onPaintOverlay(int absx, int absy)
{
	list<Console::Line> &lines = g_console.getLines();

	list<Console::Line>::iterator it;
	for (it = lines.begin(); it != lines.end();	++it)
	{
		glColor3f(it->r, it->g, it->b);
		font->print(absx, absy, 1.0f, it->text);
		absy += font->getHeight() + 2;
	}
}
