
#ifndef _include_FXWindow_hpp_
#define _include_FXWindow_hpp_ 

namespace bleifrei {
	namespace gfx {
		class Font;
	}
	namespace tex {
		class TextureRect;
	}
}

// includes
#include "bleifrei/gfx/Effect.hpp"
#include "bleifrei/gui/GUIComponent.hpp"

class FXWindow :
	public bleifrei::gui::GUIComponent
{
public:
	FXWindow(bleifrei::gfx::Effect *effect, bleifrei::gfx::Font *font, int width = 0, int height = 0, int x = 0, int y = 0);
	~FXWindow(void);

	void setEffect(bleifrei::gfx::Effect *effect);

protected:
	void onPaintBackground(int absx, int absy);
	void onMouseDown(int x, int y);
	void onMouseMove(int x, int y);

	bleifrei::gfx::Font *m_font;
	bleifrei::gfx::Effect *m_effect;
	bleifrei::gfx::Effect::technique_iterator m_technique;
	bleifrei::gfx::Effect::parameter_iterator m_framebufferParam;
	bleifrei::gfx::Effect::parameter_iterator m_firstFrameParam;
	bleifrei::gfx::Effect::parameter_iterator m_windowPosition;
	bleifrei::tex::TextureRect *m_texture;
	bleifrei::tex::TextureRect *m_firstFrameTexture;
	int lastX;
	int lastY;
	bool m_resizeX;
	bool m_resizeY;
};


#endif //_include_FXWindow_hpp_
