
// includes
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/tex/Texture.hpp"

#include "Label.hpp"

using namespace bleifrei::gfx;
using namespace bleifrei::math;
using namespace bleifrei::tex;
using namespace std;

extern int g_width;
extern int g_height;

Label::Label(const Vector3f &color, const string &text, Font *font, int x, int y, int width, int height)
	: m_text(text), font(font), color(color)
{
	move(x, y);
	resize(width, height);
}

void
Label::setText(const string &text)
{
	m_text = text;
	if (font)
	{
		resize(font->getWidth(text), getHeight());
		calculatePosition(g_width, g_height);
	}
}

void Label::onPaintOverlay(int absx, int absy)
{
	glColor3fv(&color[0]);
	font->print(absx, absy, 1.0f, m_text);
}
