
// includes
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/tex/Texture.hpp"
#include "bleifrei/tex/TextureManager.hpp"

#include "ScrollBar.hpp"

using namespace bleifrei::gfx;
using namespace bleifrei::tex;
using namespace bleifrei;

ScrollBar::ScrollBar(int x, int y, int width, int height)
{
	move(x, y);
	resize(width, height);
	setSliderSize(16);
	m_texture = TextureManager::getInstance().load("GUI_slider.tga");
}

ScrollBar::~ScrollBar(void)
{
}

void ScrollBar::onPaintOverlay(int absx, int absy)
{
	const int space = 2;
	m_texture->bind();

	glEnable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(1,1,1,1);

	if (isVertical()) {
/*		int pos = (int)(getPosition() * (getHeight() - getSliderSize() - 1));
		glBegin(GL_QUADS);
		{

			glVertex2i(absx, absy);
			glVertex2i(absx, absy + getHeight());
			glVertex2i(absx + getWidth(), absy + getHeight());
			glVertex2i(absx + getWidth(), absy);
		}
		glEnd();

		glBegin(GL_LINE_LOOP);
			glVertex2i(absx + space, absy + space + pos);
			glVertex2i(absx + space, absy - space + pos + getSliderSize());
			glVertex2i(absx - space + getWidth() - 1, absy - space + pos + getSliderSize());
			glVertex2i(absx - space + getWidth() - 1, absy + space + pos);
		glEnd();*/
	}
	else {
		int pos = (int)(getPosition() * (getWidth() - getSliderSize() - 2 * space));
		glBegin(GL_QUADS);
		{
			glTexCoord2f(0,0);
			glVertex2i(absx, absy);
			glTexCoord2f(1,0);
			glVertex2i(absx, absy + getHeight());
			glTexCoord2f(1,0.25f);
			glVertex2i(absx + 8, absy + getHeight());
			glTexCoord2f(0,0.25f);
			glVertex2i(absx + 8, absy);

			glTexCoord2f(0,0.25f);
			glVertex2i(absx + getWidth() - 8, absy);
			glTexCoord2f(1,0.25f);
			glVertex2i(absx + getWidth() - 8, absy + getHeight());
			glTexCoord2f(1,0.5f);
			glVertex2i(absx + getWidth(), absy + getHeight());
			glTexCoord2f(0,0.5f);
			glVertex2i(absx + getWidth(), absy);

			glTexCoord2f(0,0.25f);
			glVertex2i(absx + 8, absy);
			glTexCoord2f(1,0.25f);
			glVertex2i(absx + 8, absy + getHeight());
			glTexCoord2f(1,0.25f);
			glVertex2i(absx + getWidth() - 8, absy + getHeight());
			glTexCoord2f(0,0.25f);
			glVertex2i(absx + getWidth() - 8, absy);

			glTexCoord2f(0,0.5f);
			glVertex2i(absx + pos + space, absy);
			glTexCoord2f(1,0.5f);
			glVertex2i(absx + pos + space, absy + getHeight());
			glTexCoord2f(1,1.0f);
			glVertex2i(absx + pos + space + getSliderSize(), absy + getHeight());
			glTexCoord2f(0,1.0f);
			glVertex2i(absx + pos + space + getSliderSize(), absy);
		}
		glEnd();
	}
	glDisable(GL_BLEND);
}
